import { getNextElement as m, getNextMarker as h, insert as g, createComponent as d, memo as fn, template as p, setProperty as xe, effect as me, setAttribute as Ee, runHydrationEvents as ve, delegateEvents as ze, use as He, spread as mn, mergeProps as gn, hydrate as pn, render as kn } from "solid-js/web";
import { syntaxTree as le, syntaxHighlighting as Te, HighlightStyle as De } from "@codemirror/language";
import { SelectionRange as hn, EditorSelection as bn, Compartment as ye, RangeSetBuilder as Oe, EditorState as xn, StateField as vn, RangeSet as te } from "@codemirror/state";
import { defaultKeymap as yn, historyKeymap as wn, history as $n } from "@codemirror/commands";
import { EditorView as V, Decoration as j, ViewPlugin as Pe, keymap as _n } from "@codemirror/view";
import { markdown as qe, markdownLanguage as Ie } from "@codemirror/lang-markdown";
import { languages as Ne } from "@codemirror/language-data";
import { tags as u, Tag as Mn } from "@lezer/highlight";
import { createSignal as R, Show as x, onMount as Re, onCleanup as Sn, For as Cn, createEffect as Ln, createContext as En, useContext as jn } from "solid-js";
const Bn = "data-ink-mde-ssr-hydration-marker", An = `[${Bn}]`, zn = () => ({}), Hn = ([e]) => {
  const { editor: n } = e();
  n.destroy();
}, ge = ([e]) => {
  const { editor: n } = e();
  n.hasFocus || n.focus();
};
var ie = /* @__PURE__ */ ((e) => (e.Auto = "auto", e.Dark = "dark", e.Light = "light", e))(ie || {}), v = /* @__PURE__ */ ((e) => (e.Bold = "bold", e.Code = "code", e.CodeBlock = "code_block", e.Heading = "heading", e.Image = "image", e.Italic = "italic", e.Link = "link", e.List = "list", e.OrderedList = "ordered_list", e.Quote = "quote", e.TaskList = "task_list", e))(v || {}), pe = /* @__PURE__ */ ((e) => (e.End = "end", e.Start = "start", e))(pe || {});
const je = {
  auto: "auto",
  dark: "dark",
  light: "light"
}, W = {
  completion: "completion",
  default: "default",
  grammar: "grammar",
  language: "language"
}, Ve = (e) => {
  const n = e.map((t) => hn.fromJSON({ anchor: t.start, head: t.end }));
  return bn.create(n);
}, We = (e) => e.ranges.map((t) => ({
  end: t.anchor < t.head ? t.head : t.anchor,
  start: t.head < t.anchor ? t.head : t.anchor
})), A = (e) => ({ ...{
  block: !1,
  line: !1,
  multiline: !1,
  nodes: [],
  prefix: "",
  prefixStates: [],
  suffix: ""
}, ...e }), Tn = {
  [v.Bold]: A({
    nodes: ["StrongEmphasis"],
    prefix: "**",
    suffix: "**"
  }),
  [v.Code]: A({
    nodes: ["InlineCode"],
    prefix: "`",
    suffix: "`"
  }),
  [v.CodeBlock]: A({
    block: !0,
    nodes: ["FencedCode"],
    prefix: "```\n",
    suffix: "\n```"
  }),
  [v.Heading]: A({
    multiline: !0,
    nodes: ["ATXHeading1", "ATXHeading2", "ATXHeading3", "ATXHeading4", "ATXHeading5", "ATXHeading6"],
    prefix: "# ",
    prefixStates: ["# ", "## ", "### ", "#### ", "##### ", "###### ", ""]
  }),
  [v.Image]: A({
    nodes: ["Image"],
    prefix: "![](",
    suffix: ")"
  }),
  [v.Italic]: A({
    nodes: ["Emphasis"],
    prefix: "*",
    suffix: "*"
  }),
  [v.Link]: A({
    nodes: ["Link"],
    prefix: "[](",
    suffix: ")"
  }),
  [v.OrderedList]: A({
    line: !0,
    multiline: !0,
    nodes: ["OrderedList"],
    prefix: "1. "
  }),
  [v.Quote]: A({
    line: !0,
    multiline: !0,
    nodes: ["Blockquote"],
    prefix: "> "
  }),
  [v.TaskList]: A({
    line: !0,
    multiline: !0,
    nodes: ["BulletList"],
    prefix: "- [ ] "
  }),
  [v.List]: A({
    line: !0,
    multiline: !0,
    nodes: ["BulletList"],
    prefix: "- "
  })
}, Dn = ({ editor: e, selection: n }) => {
  let t = n.start;
  const r = [];
  for (; t <= n.end; ) {
    const o = e.lineBlockAt(t), i = Math.max(n.start, o.from), a = Math.min(n.end, o.to);
    r.push({ start: i, end: a }), t = o.to + 1;
  }
  return r;
}, On = ({ editor: e, formatDefinition: n, selection: t }) => {
  if (!e || !n)
    return t || { start: 0, end: 0 };
  const r = t || We(e.state.selection).pop() || { start: 0, end: 0 };
  if (n.block || n.line || n.multiline) {
    const a = e.lineBlockAt(r.start).from, s = e.lineBlockAt(r.end).to;
    return { start: a, end: s };
  }
  const o = e.state.wordAt(r.start)?.from || r.start, i = e.state.wordAt(r.end)?.to || r.end;
  return { start: o, end: i };
}, Fe = (e) => e.editor.state.sliceDoc(e.selection.start, e.selection.end), Pn = (e, n, t) => qn(e, t).find(({ type: o }) => n.nodes.includes(o.name)), qn = (e, n) => {
  const t = [];
  return le(e.state).iterate({
    from: n.start,
    to: n.end,
    enter: ({ type: r, from: o, to: i }) => {
      t.push({ type: r, from: o, to: i });
    }
  }), t;
}, we = (e) => {
  const n = Fe(e), t = e.formatDefinition.prefix.length, r = e.formatDefinition.suffix.length * -1 || n.length, o = n.slice(t, r);
  return [{ from: e.selection.start, to: e.selection.end, insert: o }];
}, In = (e) => {
  if (e.node) {
    const n = e.node.from, t = e.node.to;
    return we({ ...e, selection: { start: n, end: t } });
  } else {
    const n = e.formatDefinition.prefix, t = e.formatDefinition.suffix;
    return [
      { from: e.selection.start, insert: n },
      { from: e.selection.end, insert: t }
    ];
  }
}, Nn = (e) => {
  const n = Dn(e), t = [];
  return n.forEach((r) => {
    const o = Ue({ ...e, selection: r });
    t.push(...o);
  }), t;
}, Ue = (e) => {
  const n = e.formatDefinition.prefixStates.length > 0, t = Fe(e);
  if (e.node && n) {
    const r = e.formatDefinition.prefixStates.find((o) => t.startsWith(o));
    if (r) {
      const o = e.formatDefinition.prefixStates.indexOf(r), i = e.formatDefinition.prefixStates[o + 1], a = t.replace(new RegExp(`^${r}`), i);
      return [{ from: e.selection.start, to: e.selection.end, insert: a }];
    }
  } else if (e.node && t.startsWith(e.formatDefinition.prefix))
    return we(e);
  return [{ from: e.selection.start, insert: e.formatDefinition.prefix }];
}, Rn = (e) => {
  if (e.node) {
    const n = e.node.from, t = e.node.to;
    return we({ ...e, selection: { start: n, end: t } });
  } else {
    const { formatDefinition: n, selection: t } = e, r = Array.isArray(n.prefix) ? n.prefix[0] : n.prefix, o = n.suffix;
    return [
      { from: t.start, insert: r },
      { from: t.end, insert: o }
    ];
  }
}, Vn = (e) => e.formatDefinition.block ? In(e) : e.formatDefinition.multiline ? Nn(e) : e.formatDefinition.line ? Ue(e) : Rn(e), Qe = ([e], n, { selection: t } = {}) => {
  const { editor: r } = e(), o = Tn[n], i = On({ editor: r, formatDefinition: o, selection: t }), a = Pn(r, o, i), l = Vn({
    editor: r,
    formatDefinition: o,
    node: a,
    selection: i
  }), c = l.reduce((_, y) => {
    const S = y.insert.length - ((y.to || y.from) - y.from);
    return _ + S;
  }, 0), f = e().editor.state.update({ changes: l, selection: { head: i.start, anchor: i.end + c } });
  e().editor.dispatch(f);
}, Wn = ([e]) => {
  const { editor: n } = e();
  return n.state.sliceDoc();
}, $e = ([e]) => {
  const { editor: n } = e();
  return We(n.state.selection);
}, ce = ([e, n], t, r, o = !1) => {
  const { editor: i } = e();
  let a = r?.start, s = r?.end || r?.start;
  if (typeof a > "u") {
    const c = $e([e, n]).pop();
    a = c.start, s = c.end;
  }
  const l = { changes: { from: a, to: s, insert: t } };
  if (o) {
    const c = a === s ? a + t.length : a, f = a + t.length;
    Object.assign(l, { selection: { anchor: c, head: f } });
  }
  i.dispatch(
    i.state.update(l)
  );
}, Fn = {
  array: "[object Array]",
  asyncFunction: "[object AsyncFunction]",
  boolean: "[object Boolean]",
  function: "[object Function]",
  null: "[object Null]",
  number: "[object Number]",
  object: "[object Object]",
  promise: "[object Promise]",
  string: "[object String]",
  symbol: "[object Symbol]",
  undefined: "[object Undefined]",
  window: "[object Window]"
}, Un = (e, n) => Object.prototype.toString.call(n) === e, Xe = (e) => Un(Fn.promise, e), de = (e) => Kn(e, Xe), Qn = (e, n) => n.type === e, Xn = (e, n) => !!e && e in n, Q = (e, n) => Ke(n.plugins).reduce((t, r) => (Qn(e, r) && (!r.key || Xn(r.key, n) && n[r.key]) && t.push(r.value), t), []), Ke = (e) => e.reduce((n, t) => Array.isArray(t) ? n.concat(Ke(t)) : n.concat(t), []), Kn = (e, n) => e.reduce((t, r) => (n(r) ? t[0].push(r) : t[1].push(r), t), [[], []]), Yn = ([e, n]) => {
  const t = [], [r, o] = Zn(e().options), [i, a] = Jn(e().options);
  return Math.max(r.length, i.length) > 0 && e().workQueue.enqueue(async () => {
    const s = await ue([e, n]);
    e().editor.dispatch({ effects: s });
  }), qe({
    base: Ie,
    codeLanguages: [...Ne, ...a],
    extensions: [...t, ...o]
  });
}, Zn = (e) => de(Q(W.grammar, e)), Jn = (e) => de(Q(W.language, e)), Gn = async ([e]) => {
  const n = [], t = await Promise.all(Q(W.grammar, e().options)), r = await Promise.all(Q(W.language, e().options));
  return qe({
    base: Ie,
    codeLanguages: [...Ne, ...r],
    extensions: [...n, ...t]
  });
}, et = () => {
  const e = new ye();
  return {
    compartment: e,
    initialValue: (n) => e.of(Yn(n)),
    reconfigure: async (n) => e.reconfigure(await Gn(n))
  };
}, Be = () => document.createElement("div"), Ye = () => window.matchMedia("(prefers-color-scheme: dark)").matches, nt = (e) => e === ie.Dark ? !0 : e === ie.Light ? !1 : Ye(), fe = (e) => {
  const n = [
    // --ink-*
    { suffix: "border-radius", default: "0.25rem" },
    { suffix: "color", default: "currentColor" },
    { suffix: "flex-direction", default: "column" },
    { suffix: "font-family", default: "inherit" },
    // --ink-block-*
    { suffix: "block-background-color", default: "#121212", light: "#f5f5f5" },
    { suffix: "block-background-color-on-hover", default: "#0f0f0f", light: "#e0e0e0" },
    { suffix: "block-max-height", default: "20rem" },
    { suffix: "block-padding", default: "0.5rem" },
    // --ink-code-*
    { suffix: "code-background-color", default: "var(--ink-internal-block-background-color)" },
    { suffix: "code-color", default: "inherit" },
    { suffix: "code-font-family", default: "'Monaco', Courier, monospace" },
    // --ink-editor-*
    { suffix: "editor-font-size", default: "1em" },
    { suffix: "editor-line-height", default: "2em" },
    { suffix: "editor-padding", default: "0.5rem" },
    { suffix: "inline-padding", default: "0.125rem" },
    // --ink-modal-*
    { suffix: "modal-position", default: "fixed" },
    // --ink-syntax-*
    { suffix: "syntax-atom-color", default: "#d19a66" },
    { suffix: "syntax-comment-color", default: "#abb2bf" },
    { suffix: "syntax-comment-font-style", default: "italic" },
    { suffix: "syntax-emphasis-color", default: "inherit" },
    { suffix: "syntax-emphasis-font-style", default: "italic" },
    { suffix: "syntax-hashtag-background-color", default: "#222", light: "#eee" },
    { suffix: "syntax-hashtag-color", default: "inherit" },
    { suffix: "syntax-heading-color", default: "inherit" },
    { suffix: "syntax-heading-font-weight", default: "600" },
    { suffix: "syntax-heading1-color", default: "var(--ink-internal-syntax-heading-color, inherit)" },
    { suffix: "syntax-heading1-font-size", default: "1.6em" },
    { suffix: "syntax-heading1-font-weight", default: "600" },
    { suffix: "syntax-heading2-color", default: "var(--ink-internal-syntax-heading-color, inherit)" },
    { suffix: "syntax-heading2-font-size", default: "1.5em" },
    { suffix: "syntax-heading2-font-weight", default: "600" },
    { suffix: "syntax-heading3-color", default: "var(--ink-internal-syntax-heading-color, inherit)" },
    { suffix: "syntax-heading3-font-size", default: "1.4em" },
    { suffix: "syntax-heading3-font-weight", default: "600" },
    { suffix: "syntax-heading4-color", default: "var(--ink-internal-syntax-heading-color, inherit)" },
    { suffix: "syntax-heading4-font-size", default: "1.3em" },
    { suffix: "syntax-heading4-font-weight", default: "600" },
    { suffix: "syntax-heading5-color", default: "var(--ink-internal-syntax-heading-color, inherit)" },
    { suffix: "syntax-heading5-font-size", default: "1.2em" },
    { suffix: "syntax-heading5-font-weight", default: "600" },
    { suffix: "syntax-heading6-color", default: "var(--ink-internal-syntax-heading-color, inherit)" },
    { suffix: "syntax-heading6-font-size", default: "1.1em" },
    { suffix: "syntax-heading6-font-weight", default: "600" },
    { suffix: "syntax-highlight-background-color", default: "#555555" },
    { suffix: "syntax-keyword-color", default: "#c678dd" },
    { suffix: "syntax-link-color", default: "inherit" },
    { suffix: "syntax-meta-color", default: "#abb2bf" },
    { suffix: "syntax-monospace-color", default: "var(--ink-internal-code-color)" },
    { suffix: "syntax-monospace-font-family", default: "var(--ink-internal-code-font-family)" },
    { suffix: "syntax-name-color", default: "#d19a66" },
    { suffix: "syntax-name-label-color", default: "#abb2bf" },
    { suffix: "syntax-name-property-color", default: "#96c0d8" },
    { suffix: "syntax-name-property-definition-color", default: "#e06c75" },
    { suffix: "syntax-name-variable-color", default: "#e06c75" },
    { suffix: "syntax-name-variable-definition-color", default: "#e5c07b" },
    { suffix: "syntax-name-variable-local-color", default: "#d19a66" },
    { suffix: "syntax-name-variable-special-color", default: "inherit" },
    { suffix: "syntax-number-color", default: "#d19a66" },
    { suffix: "syntax-operator-color", default: "#96c0d8" },
    { suffix: "syntax-processing-instruction-color", default: "#444444", light: "#bbbbbb" },
    { suffix: "syntax-punctuation-color", default: "#abb2bf" },
    { suffix: "syntax-strikethrough-color", default: "inherit" },
    { suffix: "syntax-strikethrough-text-decoration", default: "line-through" },
    { suffix: "syntax-string-color", default: "#98c379" },
    { suffix: "syntax-string-special-color", default: "inherit" },
    { suffix: "syntax-strong-color", default: "inherit" },
    { suffix: "syntax-strong-font-weight", default: "600" },
    { suffix: "syntax-url-color", default: "#aaaaaa", light: "#666666" },
    { suffix: "toolbar-group-spacing", default: "2rem" },
    { suffix: "toolbar-item-spacing", default: "0" }
  ], t = !nt(e.options.interface.appearance);
  return n.map((r) => {
    const o = t && r.light ? r.light : r.default;
    return `--ink-internal-${r.suffix}: var(--ink-${r.suffix}, ${o});`;
  });
}, tt = (e) => [
  V.theme({
    ".cm-scroller": {
      fontFamily: "var(--ink-internal-font-family)"
    }
  }, { dark: e })
], rt = ([e, n]) => e().extensions.map((r) => r.initialValue([e, n])), ue = async ([e, n]) => await Promise.all(
  e().extensions.map(async (r) => await r.reconfigure([e, n]))
), ot = (e) => {
  const n = new ye();
  return {
    compartment: n,
    initialValue: (t) => n.of(e(t)),
    reconfigure: (t) => n.reconfigure(e(t))
  };
}, it = (e) => {
  const n = new ye();
  return {
    compartment: n,
    initialValue: () => n.of([]),
    reconfigure: (t) => e(t, n)
  };
}, at = () => [
  et(),
  ...st.map((e) => ot(e)),
  ...lt.map((e) => it(e))
], st = [
  ([e]) => {
    const [n, t] = de(Q(W.default, e().options));
    return t;
  },
  ([e]) => {
    const n = e().options.interface.appearance === je.dark, t = e().options.interface.appearance === je.auto;
    return tt(n || t && Ye());
  }
], lt = [
  async ([e], n) => {
    const [t] = de(Q(W.default, e().options));
    return t.length > 0 ? n.reconfigure(await Promise.all(t)) : n.reconfigure([]);
  },
  async ([e], n) => {
    if (e().options.interface.autocomplete) {
      const { autocomplete: t } = await import("./autocomplete-Bv91E1zY.js");
      return n.reconfigure(t(e().options));
    }
    return n.reconfigure([]);
  },
  async ([e], n) => {
    if (e().options.interface.images) {
      const { images: t } = await import("./images-DBpBKS7p.js");
      return n.reconfigure(t());
    }
    return n.reconfigure([]);
  },
  async ([e], n) => {
    const { keybindings: t, trapTab: r } = e().options, o = r ?? t.tab, i = r ?? t.shiftTab;
    if (o || i) {
      const { indentWithTab: a } = await import("./indentWithTab-Dc_NgyPN.js");
      return n.reconfigure(a({ tab: o, shiftTab: i }));
    }
    return n.reconfigure([]);
  },
  async ([e], n) => {
    if (e().options.interface.lists) {
      const { lists: t } = await import("./lists-qaNS34UV.js");
      return n.reconfigure(t());
    }
    return n.reconfigure([]);
  },
  async ([e], n) => {
    if (e().options.placeholder) {
      const { placeholder: t } = await import("./placeholder-CkKX2y6L.js");
      return n.reconfigure(t(e().options.placeholder));
    }
    return n.reconfigure([]);
  },
  async ([e], n) => {
    if (e().options.interface.readonly) {
      const { readonly: t } = await import("./readonly-tcxWvTqP.js");
      return n.reconfigure(t());
    }
    return n.reconfigure([]);
  },
  async ([e], n) => {
    if (e().options.search) {
      const { search: t } = await import("./search-CWpMe5al.js");
      return n.reconfigure(t());
    }
    return n.reconfigure([]);
  },
  async ([e], n) => {
    if (e().options.interface.spellcheck) {
      const { spellcheck: t } = await import("./spellcheck-DIi2vwCn.js");
      return n.reconfigure(t());
    }
    return n.reconfigure([]);
  },
  async ([e], n) => {
    if (e().options.vim) {
      const { vim: t } = await import("./vim-BYkc2D-Z.js");
      return n.reconfigure(t());
    }
    return n.reconfigure([]);
  }
], ct = [
  "Blockquote"
], dt = j.line({ attributes: { class: "cm-blockquote" } }), ut = j.line({ attributes: { class: "cm-blockquote-open" } }), ft = j.line({ attributes: { class: "cm-blockquote-close" } }), mt = Pe.define((e) => ({
  update: () => gt(e)
}), { decorations: (e) => e.update() }), gt = (e) => {
  const n = new Oe(), t = le(e.state);
  for (const r of e.visibleRanges)
    for (let o = r.from; o < r.to; ) {
      const i = e.state.doc.lineAt(o);
      t.iterate({
        enter({ type: a, from: s, to: l }) {
          if (a.name !== "Document" && ct.includes(a.name)) {
            n.add(i.from, i.from, dt);
            const c = e.state.doc.lineAt(s), f = e.state.doc.lineAt(l);
            return c.number === i.number && n.add(i.from, i.from, ut), f.number === i.number && n.add(i.from, i.from, ft), !1;
          }
        },
        from: i.from,
        to: i.to
      }), o = i.to + 1;
    }
  return n.finish();
}, pt = () => [
  mt
], kt = [
  "CodeBlock",
  "FencedCode",
  "HTMLBlock",
  "CommentBlock"
], X = {
  // Prevent spellcheck in all code blocks. The Grammarly extension might not respect these values.
  "data-enable-grammarly": "false",
  "data-gramm": "false",
  "data-grammarly-skip": "true",
  spellcheck: "false"
}, ht = j.line({ attributes: { ...X, class: "cm-codeblock" } }), bt = j.line({ attributes: { ...X, class: "cm-codeblock-open" } }), xt = j.line({ attributes: { ...X, class: "cm-codeblock-close" } }), vt = j.mark({ attributes: { ...X, class: "cm-code" } }), yt = j.mark({ attributes: { ...X, class: "cm-code cm-code-open" } }), wt = j.mark({ attributes: { ...X, class: "cm-code cm-code-close" } }), $t = Pe.define((e) => ({
  update: () => _t(e)
}), { decorations: (e) => e.update() }), _t = (e) => {
  const n = new Oe(), t = le(e.state);
  for (const r of e.visibleRanges)
    for (let o = r.from; o < r.to; ) {
      const i = e.state.doc.lineAt(o);
      let a;
      t.iterate({
        enter({ type: s, from: l, to: c }) {
          if (s.name !== "Document")
            if (kt.includes(s.name)) {
              n.add(i.from, i.from, ht);
              const f = e.state.doc.lineAt(l), _ = e.state.doc.lineAt(c);
              return f.number === i.number && n.add(i.from, i.from, bt), _.number === i.number && n.add(i.from, i.from, xt), !1;
            } else
              s.name === "InlineCode" ? a = { from: l, to: c, innerFrom: l, innerTo: c } : s.name === "CodeMark" && (l === a.from ? (a.innerFrom = c, n.add(l, c, yt)) : c === a.to && (a.innerTo = l, n.add(a.innerFrom, a.innerTo, vt), n.add(l, c, wt)));
        },
        from: i.from,
        to: i.to
      }), o = i.to + 1;
    }
  return n.finish();
}, Mt = () => [
  $t
], St = () => [
  V.editorAttributes.of({
    class: "ink-mde-container"
  }),
  V.contentAttributes.of({
    class: "ink-mde-editor-content"
  })
  // Todo: Maybe open a PR to add scrollerAttributes?
], Ct = () => [
  ...St()
], Lt = () => V.lineWrapping, Et = () => [
  Te(
    De.define([
      // ordered by lowest to highest precedence
      {
        tag: u.atom,
        color: "var(--ink-internal-syntax-atom-color)"
      },
      {
        tag: u.meta,
        color: "var(--ink-internal-syntax-meta-color)"
      },
      // emphasis types
      {
        tag: u.emphasis,
        color: "var(--ink-internal-syntax-emphasis-color)",
        fontStyle: "var(--ink-internal-syntax-emphasis-font-style)"
      },
      {
        tag: u.strong,
        color: "var(--ink-internal-syntax-strong-color)",
        fontWeight: "var(--ink-internal-syntax-strong-font-weight)"
      },
      {
        tag: u.strikethrough,
        color: "var(--ink-internal-syntax-strikethrough-color)",
        textDecoration: "var(--ink-internal-syntax-strikethrough-text-decoration)"
      },
      // comment group
      {
        tag: u.comment,
        color: "var(--ink-internal-syntax-comment-color)",
        fontStyle: "var(--ink-internal-syntax-comment-font-style)"
      },
      // monospace
      {
        tag: u.monospace,
        color: "var(--ink-internal-syntax-code-color)",
        fontFamily: "var(--ink-internal-syntax-code-font-family)"
      },
      // name group
      {
        tag: u.name,
        color: "var(--ink-internal-syntax-name-color)"
      },
      {
        tag: u.labelName,
        color: "var(--ink-internal-syntax-name-label-color)"
      },
      {
        tag: u.propertyName,
        color: "var(--ink-internal-syntax-name-property-color)"
      },
      {
        tag: u.definition(u.propertyName),
        color: "var(--ink-internal-syntax-name-property-definition-color)"
      },
      {
        tag: u.variableName,
        color: "var(--ink-internal-syntax-name-variable-color)"
      },
      {
        tag: u.definition(u.variableName),
        color: "var(--ink-internal-syntax-name-variable-definition-color)"
      },
      {
        tag: u.local(u.variableName),
        color: "var(--ink-internal-syntax-name-variable-local-color)"
      },
      {
        tag: u.special(u.variableName),
        color: "var(--ink-internal-syntax-name-variable-special-color)"
      },
      // headings
      {
        tag: u.heading,
        color: "var(--ink-internal-syntax-heading-color)",
        fontWeight: "var(--ink-internal-syntax-heading-font-weight)"
      },
      {
        tag: u.heading1,
        color: "var(--ink-internal-syntax-heading1-color)",
        fontSize: "var(--ink-internal-syntax-heading1-font-size)",
        fontWeight: "var(--ink-internal-syntax-heading1-font-weight)"
      },
      {
        tag: u.heading2,
        color: "var(--ink-internal-syntax-heading2-color)",
        fontSize: "var(--ink-internal-syntax-heading2-font-size)",
        fontWeight: "var(--ink-internal-syntax-heading2-font-weight)"
      },
      {
        tag: u.heading3,
        color: "var(--ink-internal-syntax-heading3-color)",
        fontSize: "var(--ink-internal-syntax-heading3-font-size)",
        fontWeight: "var(--ink-internal-syntax-heading3-font-weight)"
      },
      {
        tag: u.heading4,
        color: "var(--ink-internal-syntax-heading4-color)",
        fontSize: "var(--ink-internal-syntax-heading4-font-size)",
        fontWeight: "var(--ink-internal-syntax-heading4-font-weight)"
      },
      {
        tag: u.heading5,
        color: "var(--ink-internal-syntax-heading5-color)",
        fontSize: "var(--ink-internal-syntax-heading5-font-size)",
        fontWeight: "var(--ink-internal-syntax-heading5-font-weight)"
      },
      {
        tag: u.heading6,
        color: "var(--ink-internal-syntax-heading6-color)",
        fontSize: "var(--ink-internal-syntax-heading6-font-size)",
        fontWeight: "var(--ink-internal-syntax-heading6-font-weight)"
      },
      // contextual tag types
      {
        tag: u.keyword,
        color: "var(--ink-internal-syntax-keyword-color)"
      },
      {
        tag: u.number,
        color: "var(--ink-internal-syntax-number-color)"
      },
      {
        tag: u.operator,
        color: "var(--ink-internal-syntax-operator-color)"
      },
      {
        tag: u.punctuation,
        color: "var(--ink-internal-syntax-punctuation-color)"
      },
      {
        tag: u.link,
        color: "var(--ink-internal-syntax-link-color)"
      },
      {
        tag: u.url,
        color: "var(--ink-internal-syntax-url-color)"
      },
      // string group
      {
        tag: u.string,
        color: "var(--ink-internal-syntax-string-color)"
      },
      {
        tag: u.special(u.string),
        color: "var(--ink-internal-syntax-string-special-color)"
      },
      // processing instructions
      {
        tag: u.processingInstruction,
        color: "var(--ink-internal-syntax-processing-instruction-color)"
      }
    ])
  )
], jt = (e) => {
  if (e.length > 0)
    return Ve(e);
}, Ze = ([e, n]) => {
  const { selections: t } = e().options;
  return xn.create({
    doc: e().options.doc,
    selection: jt(t),
    extensions: [
      _n.of([
        ...yn,
        ...wn
      ]),
      pt(),
      Mt(),
      $n(),
      Ct(),
      Lt(),
      Et(),
      ...rt([e, n])
    ]
  });
}, Bt = ([e, n], t) => {
  const r = t?.getRootNode(), o = r?.nodeType === 11 ? r : void 0, i = new V({
    dispatch: (a) => {
      const { options: s } = e(), l = a.newDoc.toString();
      s.hooks.beforeUpdate(l), i.update([a]), a.docChanged && (n({ ...e(), doc: l }), s.hooks.afterUpdate(l));
    },
    root: o,
    state: Ze([e, n])
  });
  return i;
}, N = {
  array: "[object Array]",
  object: "[object Object]",
  string: "[object String]",
  undefined: "[object Undefined]",
  window: "[object Window]"
}, At = (e) => {
  if (Object.prototype.toString.call(e) === N.object)
    return `[object ${e.constructor.name}]`;
}, U = (e, n) => At(e) === n, zt = (e, n) => {
  const t = /* @__PURE__ */ new WeakMap(), r = (o, i) => t.get(o) || (U(o, N.object) && t.set(o, !0), U(i, N.undefined)) ? o : U(o, N.array) && U(i, N.array) ? [...i] : U(o, N.object) && U(i, N.object) ? Object.keys(o).reduce((a, s) => (Object.hasOwnProperty.call(i, s) ? a[s] = r(o[s], i[s]) : a[s] = o[s], a), {}) : i;
  return r(e, n);
}, ee = (e, n) => zt(e, n), Ht = ([e, n], t) => {
  n(ee(e(), { options: { doc: t } })), e().editor.setState(Ze([e, n]));
}, Tt = ([e]) => e().options, Dt = async ([e, n], t) => {
  const { workQueue: r } = e();
  return r.enqueue(async () => {
    n(ee(e(), { options: t }));
    const o = await ue([e, n]);
    e().editor.dispatch({ effects: o });
  });
}, Je = (e, n = {}) => {
  if (n.selections)
    return Ge(e, n.selections);
  if (n.selection)
    return ke(e, n.selection);
  if (n.at)
    return Ot(e, n.at);
}, Ot = (e, n) => {
  const [t] = e;
  if (n === pe.Start)
    return ke(e, { start: 0, end: 0 });
  if (n === pe.End) {
    const r = t().editor.state.doc.length;
    return ke(e, { start: r, end: r });
  }
}, Ge = ([e], n) => {
  const { editor: t } = e();
  t.dispatch(
    t.state.update({
      selection: Ve(n)
    })
  );
}, ke = (e, n) => Ge(e, [n]), Pt = ([e], n) => {
  const { editor: t } = e();
  t.dispatch(
    t.state.update({
      changes: {
        from: 0,
        to: t.state.doc.length,
        insert: n
      }
    })
  );
}, qt = ([e, n], { after: t, before: r, selection: o }) => {
  const { editor: i } = e(), a = o || $e([e, n]).pop() || { start: 0, end: 0 }, s = i.state.sliceDoc(a.start, a.end);
  ce([e, n], `${r}${s}${t}`, a), Je([e, n], { selections: [{ start: a.start + r.length, end: a.end + r.length }] });
}, It = (e, n) => {
  const t = {
    callbacks: {
      fulfilled: [],
      rejected: [],
      settled: []
    },
    status: "pending"
  }, r = (s, { resolve: l, reject: c }) => () => {
    try {
      const f = s(t.value);
      Promise.resolve(f).then(l, c);
    } catch (f) {
      c(f);
    }
  }, o = (s) => {
    t.status === "pending" && (t.status = "rejected", t.value = s, t.callbacks.rejected.forEach((l) => l()), t.callbacks.settled.forEach((l) => l()));
  }, i = (s) => {
    t.status === "pending" && (t.status = "fulfilled", t.value = s, t.callbacks.fulfilled.forEach((l) => l()), t.callbacks.settled.forEach((l) => l()));
  }, a = (s, l) => new Promise((c, f) => {
    t.status === "pending" && (s && t.callbacks.fulfilled.push(r(s, { resolve: c, reject: f })), l && t.callbacks.rejected.push(r(l, { resolve: void 0, reject: f }))), t.status === "fulfilled" && s && r(s, { resolve: c, reject: f })(), t.status === "rejected" && l && r(l, { resolve: void 0, reject: f })();
  });
  return queueMicrotask(() => {
    try {
      n(i, o);
    } catch (s) {
      o(s);
    }
  }), {
    ...e,
    [Symbol.toStringTag]: "awaitable",
    catch: a.bind(void 0, void 0),
    finally: (s) => new Promise((l, c) => {
      t.status === "pending" && t.callbacks.settled.push(r(s, { resolve: l, reject: c })), t.status === "fulfilled" && (s(), l(t.value)), t.status === "rejected" && (s(), c(t.value));
    }),
    then: a
  };
}, en = (e) => {
  const n = {
    destroy: Hn.bind(void 0, e),
    focus: ge.bind(void 0, e),
    format: Qe.bind(void 0, e),
    getDoc: Wn.bind(void 0, e),
    insert: ce.bind(void 0, e),
    load: Ht.bind(void 0, e),
    options: Tt.bind(void 0, e),
    reconfigure: Dt.bind(void 0, e),
    select: Je.bind(void 0, e),
    selections: $e.bind(void 0, e),
    update: Pt.bind(void 0, e),
    wrap: qt.bind(void 0, e)
  };
  return It(n, (t, r) => {
    try {
      const [o] = e;
      o().workQueue.enqueue(() => t(n));
    } catch (o) {
      r(o);
    }
  });
}, Nt = (e) => rn({
  block: !0,
  side: -1,
  ...e
}), nn = (e) => j.line({
  ...e,
  type: "line"
}), Rt = (e) => j.mark({
  ...e,
  type: "mark"
}), tn = (e) => {
  const n = (t) => e.eq ? e.eq(t) : e.id ? e.id === t.id : !1;
  return {
    compare: (t) => n(t),
    coordsAt: () => null,
    destroy: () => {
    },
    eq: (t) => n(t),
    estimatedHeight: -1,
    ignoreEvent: () => !0,
    lineBreaks: 0,
    toDOM: () => document.createElement("span"),
    updateDOM: () => !1,
    ...e
  };
}, rn = (e) => j.widget({
  block: !1,
  side: 0,
  ...e,
  widget: tn({
    ...e.widget
  }),
  type: "widget"
}), oe = (e, n) => {
  const t = [];
  return le(e).iterate({
    enter: (r) => {
      if (n.nodes.includes(r.type.name)) {
        const o = n.onMatch(e, r);
        if (!o)
          return;
        Array().concat(o).forEach((a) => {
          if (a.spec.type === "line") {
            const s = nn({ ...a.spec, node: { ...r } });
            for (let l = e.doc.lineAt(r.from); l.from < r.to && (t.push(s.range(l.from)), l.to !== e.doc.length); l = e.doc.lineAt(l.to + 1))
              ;
          }
          if (a.spec.type === "mark") {
            const s = Rt({ ...a.spec, node: { ...r } }).range(r.from, r.to);
            t.push(s);
          }
          if (a.spec.type === "widget") {
            const s = rn({ ...a.spec, node: { ...r } }).range(r.from);
            t.push(s);
          }
        });
      }
    },
    from: n.range?.from,
    to: n.range?.to
  }), t.sort((r, o) => r.from - o.from);
}, Vt = (e, n, t) => {
  const r = [], o = e.iter(), i = [], a = [];
  for (; o.value; )
    i.push({ ...o }), o.next();
  n.changes.iterChangedRanges((c, f, _, y) => {
    i.forEach((w) => {
      if (w.value) {
        const q = w.value.spec.node.to - w.value.spec.node.from, I = w.from, T = w.from + q;
        Wt(I, T, _, y) && a.push(w);
      }
    });
    const S = { from: _, to: y };
    r.push(...oe(n.state, { ...t, range: S }));
  });
  const s = i.filter((c) => !a.includes(c)).flatMap((c) => {
    const f = c.value?.range(c.from);
    return f ? [f] : [];
  });
  return r.push(...s), r.sort((c, f) => c.from - f.from);
}, Wt = (e, n, t, r) => Math.max(e, t) <= Math.min(n, r), Ae = (e) => vn.define({
  create(n) {
    return te.of(oe(n, e));
  },
  update(n, t) {
    if (t.reconfigured || t.effects.length > 0)
      return te.of(oe(t.state, e));
    const r = n.map(t.changes);
    return t.docChanged ? e.optimize ? te.of(Vt(r, t, e)) : te.of(oe(t.state, e)) : r;
  },
  provide(n) {
    return V.decorations.from(n);
  }
}), Ft = (e) => Mn.define(e), Ut = (e) => e.charCodeAt(0), K = (e) => _e(e, [u.processingInstruction]), _e = (e, n = []) => {
  const t = Ft();
  return {
    node: Yt({
      name: e,
      style: [t, ...n]
    }),
    tag: t
  };
}, Qt = (e) => e, Xt = (e) => e, Kt = (e) => e, Yt = (e) => e, G = {
  dollarSign: Ut("$")
}, Zt = /\$.*?\$/, Jt = /\$(?<math>.*?)\$/, ae = _e("MathInline"), se = K("MathInlineMark"), Me = K("MathInlineMarkOpen"), Se = K("MathInlineMarkClose"), Gt = Xt({
  name: ae.node.name,
  parse: (e, n, t) => {
    if (n !== G.dollarSign)
      return -1;
    const r = e.slice(t, e.end);
    if (!Zt.test(r))
      return -1;
    const o = r.match(Jt);
    if (!o?.groups?.math)
      return -1;
    const i = o.groups.math.length;
    return e.addElement(
      e.elt(
        ae.node.name,
        t,
        t + i + 2,
        [
          e.elt(
            se.node.name,
            t,
            t + 1,
            [
              e.elt(
                Me.node.name,
                t,
                t + 1
              )
            ]
          ),
          e.elt(
            se.node.name,
            t + i + 1,
            t + i + 2,
            [
              e.elt(
                Se.node.name,
                t + i + 1,
                t + i + 2
              )
            ]
          )
        ]
      )
    );
  }
}), on = _e("MathBlock"), he = K("MathBlockMark"), an = K("MathBlockMarkOpen"), sn = K("MathBlockMarkClose"), er = Qt({
  name: "MathBlock",
  parse: (e, n) => {
    if (n.next !== G.dollarSign || n.text.charCodeAt(n.pos + 1) !== G.dollarSign)
      return !1;
    const t = e.lineStart + n.pos, r = t + n.text.length;
    for (; e.nextLine(); )
      if (n.next === G.dollarSign && n.text.charCodeAt(n.pos + 1) === G.dollarSign) {
        const o = e.lineStart + n.pos, i = o + n.text.length;
        e.addElement(
          e.elt(
            on.node.name,
            t,
            i,
            [
              e.elt(
                he.node.name,
                t,
                r,
                [
                  e.elt(
                    an.node.name,
                    t,
                    r
                  )
                ]
              ),
              e.elt(
                he.node.name,
                o,
                i,
                [
                  e.elt(
                    sn.node.name,
                    o,
                    i
                  )
                ]
              )
            ]
          )
        ), e.nextLine();
        break;
      }
    return !0;
  }
}), nr = Kt({
  defineNodes: [
    ae.node,
    se.node,
    Se.node,
    Me.node,
    on.node,
    he.node,
    an.node,
    sn.node
  ],
  parseBlock: [
    er
  ],
  parseInline: [
    Gt
  ]
}), tr = () => [
  J({
    key: "katex",
    type: W.grammar,
    value: async () => nr
  }),
  J({
    key: "katex",
    value: async () => Ae({
      nodes: ["MathBlock", "MathBlockMarkClose", "MathBlockMarkOpen"],
      onMatch: (e, n) => {
        const t = ["ink-mde-line-math-block"];
        return n.name === "MathBlockMarkOpen" && t.push("ink-mde-line-math-block-open"), n.name === "MathBlockMarkClose" && t.push("ink-mde-line-math-block-close"), nn({
          attributes: {
            class: t.join(" ")
          }
        });
      },
      optimize: !1
    })
  }),
  J({
    key: "katex",
    value: async () => Ae({
      nodes: ["MathBlock"],
      onMatch: (e, n) => {
        const t = e.sliceDoc(n.from, n.to).split(`
`).slice(1, -1).join(`
`);
        if (t)
          return Nt({
            widget: tn({
              id: t,
              toDOM: (r) => {
                const o = document.createElement("div"), i = document.createElement("div");
                return o.className = "ink-mde-block-widget-container", i.className = "ink-mde-block-widget ink-mde-katex-target", o.appendChild(i), import("katex").then(({ default: a }) => {
                  a.render(t, i, { output: "html", throwOnError: !1 }), r.requestMeasure();
                }), o;
              },
              updateDOM: (r, o) => {
                const i = r.querySelector(".ink-mde-katex-target");
                return i ? (import("katex").then(({ default: a }) => {
                  a.render(t, i, { output: "html", throwOnError: !1 }), o.requestMeasure();
                }), !0) : !1;
              }
            })
          });
      },
      optimize: !1
    })
  }),
  J({
    key: "katex",
    value: async () => Te(
      De.define([
        {
          tag: [ae.tag, se.tag],
          backgroundColor: "var(--ink-internal-block-background-color)"
        },
        {
          tag: [Se.tag],
          backgroundColor: "var(--ink-internal-block-background-color)",
          borderRadius: "0 var(--ink-internal-border-radius) var(--ink-internal-border-radius) 0",
          paddingRight: "var(--ink-internal-inline-padding)"
        },
        {
          tag: [Me.tag],
          backgroundColor: "var(--ink-internal-block-background-color)",
          borderRadius: "var(--ink-internal-border-radius) 0 0 var(--ink-internal-border-radius)",
          paddingLeft: "var(--ink-internal-inline-padding)"
        }
      ])
    )
  }),
  J({
    key: "katex",
    value: async () => V.theme({
      ".ink-mde-line-math-block": {
        backgroundColor: "var(--ink-internal-block-background-color)",
        padding: "0 var(--ink-internal-block-padding) !important"
      },
      ".ink-mde-line-math-block-open": {
        borderRadius: "var(--ink-internal-border-radius) var(--ink-internal-border-radius) 0 0"
      },
      ".ink-mde-line-math-block-close": {
        borderRadius: "0 0 var(--ink-internal-border-radius) var(--ink-internal-border-radius)"
      }
    })
  })
], rr = () => {
  const e = {
    queue: [],
    workload: 0
  }, n = async () => {
    const t = e.queue.pop();
    t && (await t(), e.workload--, await n());
  };
  return {
    enqueue: (t) => new Promise((r, o) => {
      const i = async () => {
        try {
          await t(), r();
        } catch (a) {
          o(a);
        }
      };
      e.queue.push(i), e.workload++, !(e.workload > 1) && n();
    })
  };
}, be = () => {
  const e = {
    doc: "",
    files: {
      clipboard: !1,
      dragAndDrop: !1,
      handler: () => {
      },
      injectMarkup: !0,
      types: ["image/*"]
    },
    hooks: {
      afterUpdate: () => {
      },
      beforeUpdate: () => {
      }
    },
    interface: {
      appearance: ie.Auto,
      attribution: !0,
      autocomplete: !1,
      images: !1,
      lists: !1,
      readonly: !1,
      spellcheck: !0,
      toolbar: !1
    },
    katex: !1,
    keybindings: {
      // Todo: Set these to false by default. https://codemirror.net/examples/tab
      tab: !0,
      shiftTab: !0
    },
    placeholder: "",
    plugins: [
      tr()
    ],
    readability: !1,
    search: !0,
    selections: [],
    toolbar: {
      bold: !0,
      code: !0,
      codeBlock: !0,
      heading: !0,
      image: !0,
      italic: !0,
      link: !0,
      list: !0,
      orderedList: !0,
      quote: !0,
      taskList: !0,
      upload: !1
    },
    // This value overrides both `tab` and `shiftTab` keybindings.
    trapTab: void 0,
    vim: !1
  };
  return {
    doc: "",
    editor: {},
    extensions: at(),
    options: e,
    root: Be(),
    target: Be(),
    workQueue: rr()
  };
}, or = (e) => ee(be(), e), Ce = (e, n = {}) => {
  const [t, r] = R(or({ ...n, doc: e.doc || "", options: e }));
  return [t, r];
}, Le = 225, ir = (e, n = Le) => {
  const t = lr(e, n), r = cr(e), o = sr(e), i = ar(e);
  return [t, r, o, i].join(" | ");
}, ar = (e) => `${dr(e)} chars`, sr = (e) => `${ur(e)} lines`, lr = (e, n = Le) => {
  const t = fr(e, n), r = Math.floor(t), o = Math.floor(t % 1 * 60);
  return r === 0 ? `${o}s read` : `${r}m ${o}s to read`;
}, cr = (e) => `${ln(e)} words`, dr = (e) => e.length, ur = (e) => e.split(/\n/).length, fr = (e, n = Le) => ln(e) / n, ln = (e) => {
  const n = e.replace(/[']/g, "").replace(/[^\w\d]+/g, " ").trim();
  return n ? n.split(/\s+/).length : 0;
};
var mr = /* @__PURE__ */ p("<div class=ink-mde-readability><span>"), gr = /* @__PURE__ */ p("<span>&nbsp;|"), pr = /* @__PURE__ */ p('<div class=ink-mde-attribution><span>&nbsp;powered by <a class=ink-mde-attribution-link href=https://github.com/davidmyersdev/ink-mde rel="noopener noreferrer"target=_blank>ink-mde'), kr = /* @__PURE__ */ p("<div class=ink-mde-details><div class=ink-mde-container><div class=ink-mde-details-content><!$><!/><!$><!/><!$><!/>");
const hr = () => {
  const [e] = Y();
  return (() => {
    var n = m(kr), t = n.firstChild, r = t.firstChild, o = r.firstChild, [i, a] = h(o.nextSibling), s = i.nextSibling, [l, c] = h(s.nextSibling), f = l.nextSibling, [_, y] = h(f.nextSibling);
    return g(r, d(x, {
      get when() {
        return e().options.readability;
      },
      get children() {
        var S = m(mr), w = S.firstChild;
        return g(w, () => ir(e().doc)), S;
      }
    }), i, a), g(r, d(x, {
      get when() {
        return fn(() => !!e().options.readability)() && e().options.interface.attribution;
      },
      get children() {
        return m(gr);
      }
    }), l, c), g(r, d(x, {
      get when() {
        return e().options.interface.attribution;
      },
      get children() {
        return m(pr);
      }
    }), _, y), n;
  })();
}, br = ".ink-drop-zone{align-items:center;background-color:#00000080;color:var(--ink-internal-color);display:flex;inset:0;justify-content:center;position:var(--ink-internal-modal-position);z-index:100}.ink-drop-zone:not(.visible){display:none}.ink-drop-zone-modal{background-color:var(--ink-internal-block-background-color);border-radius:var(--ink-internal-border-radius);box-sizing:border-box;height:100%;max-height:20rem;max-width:40rem;padding:1rem;position:relative;width:100%}.ink-drop-zone-hide{cursor:pointer;height:1.75rem;position:absolute;right:.25rem;top:.25rem;width:1.75rem}.ink-drop-zone-hide svg{background-color:var(--ink-internal-block-background-color)}.ink-drop-zone-droppable-area{align-items:center;border:.2rem dashed var(--ink-internal-color);border-radius:.125rem;box-sizing:border-box;display:flex;flex-direction:column;font-size:1.25em;gap:1rem;height:100%;justify-content:center;padding:1rem;text-align:center}.ink-drop-zone-file-preview{align-items:center;display:flex;flex-wrap:wrap;gap:.5rem;max-width:25.5rem}.ink-drop-zone-file-preview-image{border:.125rem solid #222;border-radius:.125rem;box-sizing:border-box;height:6rem;object-fit:cover;padding:.5rem;width:6rem}";
var xr = /* @__PURE__ */ p("<span>uploading files..."), vr = /* @__PURE__ */ p('<div class=ink-drop-zone><style></style><div class=ink-drop-zone-modal><div class=ink-drop-zone-droppable-area><div class=ink-drop-zone-file-preview></div><!$><!/></div><div class=ink-drop-zone-hide><svg xmlns=http://www.w3.org/2000/svg fill=none viewBox="0 0 24 24"stroke=currentColor><path stroke-linecap=round stroke-linejoin=round stroke-width=2 d="M10 14l2-2m0 0l2-2m-2 2l-2-2m2 2l2 2m7-2a9 9 0 11-18 0 9 9 0 0118 0z">'), yr = /* @__PURE__ */ p("<img class=ink-drop-zone-file-preview-image>"), wr = /* @__PURE__ */ p("<span>drop files here");
const $r = () => {
  const [e, n] = R(0), [t, r] = R([]), [o, i] = R(!1), [a, s] = R(!1), [l, c] = Y(), f = () => {
    s(!1);
  }, _ = (b) => {
    if (l().options.files.dragAndDrop) {
      b.preventDefault(), b.stopPropagation();
      const $ = b.dataTransfer;
      $?.files ? T($.files) : (n(0), s(!1), r([]));
    }
  }, y = (b) => {
    l().options.files.dragAndDrop && (b.preventDefault(), n(e() + 1), s(!0));
  }, S = (b) => {
    l().options.files.dragAndDrop && (b.preventDefault(), n(e() - 1), e() === 0 && s(!1));
  }, w = (b) => {
    l().options.files.dragAndDrop && (b.preventDefault(), s(!0));
  }, q = (b) => {
    l().options.files.dragAndDrop && (b.preventDefault(), n(0), s(!1));
  }, I = (b) => {
    if (l().options.files.clipboard) {
      b.preventDefault();
      const $ = b.clipboardData;
      $?.files && $.files.length > 0 && T($.files);
    }
  }, T = (b) => {
    Array.from(b).forEach(($) => {
      r([...t(), $]);
    }), i(!0), s(!0), Promise.resolve(l().options.files.handler(b)).then(($) => {
      if (l().options.files.injectMarkup && $) {
        const Z = `![](${$})`;
        ce([l, c], Z);
      }
    }).finally(() => {
      n(0), i(!1), s(!1), r([]);
    });
  };
  return Re(() => {
    document.addEventListener("dragenter", y), document.addEventListener("dragleave", S), document.addEventListener("dragover", w), document.addEventListener("drop", q), l().root.addEventListener("paste", I);
  }), Sn(() => {
    document.removeEventListener("dragenter", y), document.removeEventListener("dragleave", S), document.removeEventListener("dragover", w), document.removeEventListener("drop", q), l().root.removeEventListener("paste", I);
  }), (() => {
    var b = m(vr), $ = b.firstChild, Z = $.nextSibling, F = Z.firstChild, k = F.firstChild, D = k.nextSibling, [C, O] = h(D.nextSibling), P = F.nextSibling;
    return xe($, "textContent", br), F.addEventListener("drop", _), g(k, d(Cn, {
      get each() {
        return t().slice(0, 8);
      },
      children: (M) => (() => {
        var B = m(yr);
        return me((L) => {
          var z = M.name, H = URL.createObjectURL(M);
          return z !== L.e && Ee(B, "alt", L.e = z), H !== L.t && Ee(B, "src", L.t = H), L;
        }, {
          e: void 0,
          t: void 0
        }), B;
      })()
    })), g(F, d(x, {
      get when() {
        return o();
      },
      get fallback() {
        return m(wr);
      },
      get children() {
        return m(xr);
      }
    }), C, O), P.$$click = f, me(() => b.classList.toggle("visible", !!a())), ve(), b;
  })();
};
ze(["click"]);
const _r = (e) => {
  const [n, t] = Y(), r = Bt([n, t], e.target), {
    workQueue: o
  } = n();
  return t(ee(n(), {
    editor: r
  })), o.enqueue(async () => {
    const i = await ue([n, t]);
    r.dispatch({
      effects: i
    });
  }), r.dom;
};
var Mr = /* @__PURE__ */ p("<button class=ink-button type=button>");
const E = (e) => (() => {
  var n = m(Mr);
  return n.$$click = (t) => e.onclick(t), g(n, () => e.children), ve(), n;
})();
ze(["click"]);
const Sr = ".ink-mde .ink-mde-toolbar{background-color:var(--ink-internal-block-background-color);color:inherit;display:flex;flex-shrink:0;overflow-x:auto;padding:.25rem}.ink-mde .ink-mde-toolbar .ink-mde-container{display:flex;gap:var(--ink-internal-toolbar-group-spacing)}.ink-mde .ink-mde-toolbar-group{display:flex;gap:var(--ink-internal-toolbar-item-spacing)}.ink-mde .ink-mde-toolbar .ink-button{align-items:center;background:none;border:none;border-radius:var(--ink-internal-border-radius);color:inherit;cursor:pointer;display:flex;height:2.25rem;justify-content:center;padding:.4rem;width:2.25rem}.ink-mde .ink-mde-toolbar .ink-button:hover{background-color:var(--ink-internal-block-background-color-on-hover)}.ink-mde .ink-mde-toolbar .ink-button>*{align-items:center;display:flex;height:100%}";
var Cr = /* @__PURE__ */ p('<svg viewBox="0 0 20 20"fill=none stroke=currentColor stroke-miterlimit=5 stroke-linecap=round stroke-linejoin=round><path d="M6 4V10M6 16V10M6 10H14M14 10V4M14 10V16">'), Lr = /* @__PURE__ */ p('<svg viewBox="0 0 20 20"fill=none stroke=currentColor stroke-width=1.5 stroke-miterlimit=5 stroke-linecap=round stroke-linejoin=round><path d="M6.5 10H10.5C12.1569 10 13.5 11.3431 13.5 13C13.5 14.6569 12.1569 16 10.5 16H6.5V4H9.5C11.1569 4 12.5 5.34315 12.5 7C12.5 8.65686 11.1569 10 9.5 10">'), Er = /* @__PURE__ */ p('<svg viewBox="0 0 20 20"fill=none stroke=currentColor stroke-miterlimit=5 stroke-linecap=round stroke-linejoin=round><path d="M11 4L9 16M13 4H9M7 16H11">'), re = /* @__PURE__ */ p("<div class=ink-mde-toolbar-group><!$><!/><!$><!/><!$><!/>"), jr = /* @__PURE__ */ p('<svg viewBox="0 0 20 20"fill=none stroke=currentColor stroke-miterlimit=5 stroke-linecap=round stroke-linejoin=round><path d="M2.00257 16H17.9955M2.00055 4H18M7 10H18.0659M2 8.5V11.4999C2.4 11.5 2.5 11.5 2.5 11.5V11V10.5M4 8.5V11.4999H4.5V11V10.5">'), Br = /* @__PURE__ */ p('<svg viewBox="0 0 20 20"fill=none stroke=currentColor stroke-miterlimit=5 stroke-linecap=round stroke-linejoin=round><path d="M13 4L7 16"></path><path d="M5 7L2 10L5 13"></path><path d="M15 7L18 10L15 13">'), Ar = /* @__PURE__ */ p('<svg viewBox="0 0 20 20"fill=none stroke=currentColor stroke-miterlimit=5 stroke-linecap=round stroke-linejoin=round><path d="M7 4L8 6">'), zr = /* @__PURE__ */ p('<svg viewBox="0 0 20 20"fill=none stroke=currentColor stroke-miterlimit=5 stroke-linecap=round stroke-linejoin=round><path d="M7 16H17.8294"></path><path d="M2 16H4"></path><path d="M7 10H17.8294"></path><path d="M2 10H4"></path><path d="M7 4H17.8294"></path><path d="M2 4H4">'), Hr = /* @__PURE__ */ p('<svg viewBox="0 0 20 20"fill=none stroke=currentColor stroke-miterlimit=5 stroke-linecap=round stroke-linejoin=round><path d="M7 16H18"></path><path d="M2 17.0242C2.48314 17.7569 3.94052 17.6154 3.99486 16.7919C4.05315 15.9169 3.1975 16.0044 2.99496 16.0044M2.0023 14.9758C2.48544 14.2431 3.94282 14.3846 3.99716 15.2081C4.05545 16.0831 3.1998 16.0002 2.99726 16.0002"></path><path d="M7 10H18"></path><path d="M2.00501 11.5H4M2.00193 8.97562C2.48449 8.24319 3.9401 8.38467 3.99437 9.20777C4.05259 10.0825 2.04342 10.5788 2 11.4996"></path><path d="M7 4H18"></path><path d="M2 5.5H4M2.99713 5.49952V2.5L2.215 2.93501">'), Tr = /* @__PURE__ */ p('<svg viewBox="0 0 20 20"fill=none stroke=currentColor stroke-miterlimit=5 stroke-linecap=round stroke-linejoin=round><path d="M7 16H17.8294"></path><path d="M5 15L3 17L2 16"></path><path d="M7 10H17.8294"></path><path d="M5 9L3 11L2 10"></path><path d="M7 4H17.8294"></path><path d="M5 3L3 5L2 4">'), Dr = /* @__PURE__ */ p('<svg viewBox="0 0 20 20"fill=none stroke=currentColor stroke-miterlimit=5 stroke-linecap=round stroke-linejoin=round><path d="M9.12127 10.881C10.02 11.78 11.5237 11.7349 12.4771 10.7813L15.2546 8.00302C16.2079 7.04937 16.253 5.54521 15.3542 4.6462C14.4555 3.74719 12.9512 3.79174 11.9979 4.74539L10.3437 6.40007M10.8787 9.11903C9.97997 8.22002 8.47626 8.26509 7.52288 9.21874L4.74545 11.997C3.79208 12.9506 3.74701 14.4548 4.64577 15.3538C5.54452 16.2528 7.04876 16.2083 8.00213 15.2546L9.65633 13.5999">'), Or = /* @__PURE__ */ p('<svg viewBox="0 0 20 20"fill=none stroke=currentColor stroke-miterlimit=5 stroke-linecap=round stroke-linejoin=round><rect x=2 y=4 width=16 height=12 rx=1></rect><path d="M7.42659 7.67597L13.7751 13.8831M2.00208 12.9778L7.42844 7.67175"></path><path d="M11.9119 12.0599L14.484 9.54443L17.9973 12.9785"></path><path d="M10.9989 7.95832C11.551 7.95832 11.9986 7.52072 11.9986 6.98092C11.9986 6.44113 11.551 6.00354 10.9989 6.00354C10.4468 6.00354 9.99921 6.44113 9.99921 6.98092C9.99921 7.52072 10.4468 7.95832 10.9989 7.95832Z">'), Pr = /* @__PURE__ */ p('<svg viewBox="0 0 20 20"fill=none stroke=currentColor stroke-miterlimit=5 stroke-linecap=round stroke-linejoin=round><path d="M10 13V4M10 4L13 7M10 4L7 7"></path><path d="M2 13V15C2 15.5523 2.44772 16 3 16H17C17.5523 16 18 15.5523 18 15V13">'), qr = /* @__PURE__ */ p("<input type=file>"), Ir = /* @__PURE__ */ p("<div class=ink-mde-toolbar><style></style><div class=ink-mde-container><!$><!/><!$><!/><!$><!/><!$><!/>");
const Nr = () => {
  const [e, n] = Y(), [t, r] = R(), o = (s) => {
    Qe([e, n], s), ge([e, n]);
  }, i = (s) => {
    const l = s.target;
    l?.files && Promise.resolve(e().options.files.handler(l.files)).then((c) => {
      if (c) {
        const f = `![](${c})`;
        ce([e, n], f), ge([e, n]);
      }
    });
  }, a = () => {
    t()?.click();
  };
  return (() => {
    var s = m(Ir), l = s.firstChild, c = l.nextSibling, f = c.firstChild, [_, y] = h(f.nextSibling), S = _.nextSibling, [w, q] = h(S.nextSibling), I = w.nextSibling, [T, b] = h(I.nextSibling), $ = T.nextSibling, [Z, F] = h($.nextSibling);
    return xe(l, "textContent", Sr), g(c, d(x, {
      get when() {
        return e().options.toolbar.heading || e().options.toolbar.bold || e().options.toolbar.italic;
      },
      get children() {
        var k = m(re), D = k.firstChild, [C, O] = h(D.nextSibling), P = C.nextSibling, [M, B] = h(P.nextSibling), L = M.nextSibling, [z, H] = h(L.nextSibling);
        return g(k, d(x, {
          get when() {
            return e().options.toolbar.heading;
          },
          get children() {
            return d(E, {
              onclick: () => o(v.Heading),
              get children() {
                return m(Cr);
              }
            });
          }
        }), C, O), g(k, d(x, {
          get when() {
            return e().options.toolbar.bold;
          },
          get children() {
            return d(E, {
              onclick: () => o(v.Bold),
              get children() {
                return m(Lr);
              }
            });
          }
        }), M, B), g(k, d(x, {
          get when() {
            return e().options.toolbar.italic;
          },
          get children() {
            return d(E, {
              onclick: () => o(v.Italic),
              get children() {
                return m(Er);
              }
            });
          }
        }), z, H), k;
      }
    }), _, y), g(c, d(x, {
      get when() {
        return e().options.toolbar.quote || e().options.toolbar.codeBlock || e().options.toolbar.code;
      },
      get children() {
        var k = m(re), D = k.firstChild, [C, O] = h(D.nextSibling), P = C.nextSibling, [M, B] = h(P.nextSibling), L = M.nextSibling, [z, H] = h(L.nextSibling);
        return g(k, d(x, {
          get when() {
            return e().options.toolbar.quote;
          },
          get children() {
            return d(E, {
              onclick: () => o(v.Quote),
              get children() {
                return m(jr);
              }
            });
          }
        }), C, O), g(k, d(x, {
          get when() {
            return e().options.toolbar.codeBlock;
          },
          get children() {
            return d(E, {
              onclick: () => o(v.CodeBlock),
              get children() {
                return m(Br);
              }
            });
          }
        }), M, B), g(k, d(x, {
          get when() {
            return e().options.toolbar.code;
          },
          get children() {
            return d(E, {
              onclick: () => o(v.Code),
              get children() {
                return m(Ar);
              }
            });
          }
        }), z, H), k;
      }
    }), w, q), g(c, d(x, {
      get when() {
        return e().options.toolbar.list || e().options.toolbar.orderedList || e().options.toolbar.taskList;
      },
      get children() {
        var k = m(re), D = k.firstChild, [C, O] = h(D.nextSibling), P = C.nextSibling, [M, B] = h(P.nextSibling), L = M.nextSibling, [z, H] = h(L.nextSibling);
        return g(k, d(x, {
          get when() {
            return e().options.toolbar.list;
          },
          get children() {
            return d(E, {
              onclick: () => o(v.List),
              get children() {
                return m(zr);
              }
            });
          }
        }), C, O), g(k, d(x, {
          get when() {
            return e().options.toolbar.orderedList;
          },
          get children() {
            return d(E, {
              onclick: () => o(v.OrderedList),
              get children() {
                return m(Hr);
              }
            });
          }
        }), M, B), g(k, d(x, {
          get when() {
            return e().options.toolbar.taskList;
          },
          get children() {
            return d(E, {
              onclick: () => o(v.TaskList),
              get children() {
                return m(Tr);
              }
            });
          }
        }), z, H), k;
      }
    }), T, b), g(c, d(x, {
      get when() {
        return e().options.toolbar.link || e().options.toolbar.image || e().options.toolbar.upload;
      },
      get children() {
        var k = m(re), D = k.firstChild, [C, O] = h(D.nextSibling), P = C.nextSibling, [M, B] = h(P.nextSibling), L = M.nextSibling, [z, H] = h(L.nextSibling);
        return g(k, d(x, {
          get when() {
            return e().options.toolbar.link;
          },
          get children() {
            return d(E, {
              onclick: () => o(v.Link),
              get children() {
                return m(Dr);
              }
            });
          }
        }), C, O), g(k, d(x, {
          get when() {
            return e().options.toolbar.image;
          },
          get children() {
            return d(E, {
              onclick: () => o(v.Image),
              get children() {
                return m(Or);
              }
            });
          }
        }), M, B), g(k, d(x, {
          get when() {
            return e().options.toolbar.upload;
          },
          get children() {
            return d(E, {
              onclick: a,
              get children() {
                return [m(Pr), (() => {
                  var ne = m(qr);
                  return He(r, ne), ne.addEventListener("change", i), ne.style.setProperty("display", "none"), ne;
                })()];
              }
            });
          }
        }), z, H), k;
      }
    }), Z, F), s;
  })();
}, Rr = ".ink-mde{border:2px solid var(--ink-internal-block-background-color);border-radius:var(--ink-internal-border-radius);color:var(--ink-internal-color, inherit);display:flex;flex-direction:var(--ink-internal-flex-direction, column);font-family:var(--ink-internal-font-family)}.ink-mde .cm-cursor{border-left-color:var(--ink-internal-color, inherit);margin-left:0}.ink-mde .cm-tooltip{background-color:var(--ink-internal-block-background-color);border-radius:var(--ink-internal-border-radius);font-family:inherit;padding:.25rem}.ink-mde .cm-tooltip.cm-tooltip-autocomplete ul{font-family:inherit}.ink-mde .cm-tooltip.cm-tooltip-autocomplete ul li.ink-tooltip-option{border-radius:var(--ink-internal-border-radius);padding:.25rem}.ink-mde .cm-tooltip.cm-tooltip-autocomplete ul li.ink-tooltip-option[aria-selected]{background-color:#96969640}.ink-mde .cm-completionLabel{font-family:inherit}.ink-mde,.ink-mde *{box-sizing:border-box}.ink-mde,.ink-mde .ink-mde-editor{display:flex;flex-direction:column;flex-grow:1;flex-shrink:1;min-height:0}.ink-mde .ink-mde-editor{overflow:auto;padding:.5rem}.ink-mde .ink-mde-toolbar,.ink-mde .ink-mde-details{display:flex;flex-grow:0;flex-shrink:0}.ink-mde .ink-mde-details{background-color:var(--ink-internal-block-background-color);display:flex;padding:.5rem}.ink-mde .ink-mde-details-content{color:inherit;display:flex;filter:brightness(.75);flex-wrap:wrap;font-size:.75em;justify-content:flex-end}.ink-mde .ink-mde-attribution{display:flex;justify-content:flex-end}.ink-mde .ink-mde-attribution-link{color:currentColor;font-weight:600;text-decoration:none}.ink-mde .ink-mde-container{margin-left:auto;margin-right:auto;width:100%}.ink-mde .ink-mde-search-panel{background-color:var(--ink-internal-block-background-color);border-radius:.25rem;padding:.25rem;position:absolute;right:.25rem;top:.25rem;width:clamp(10rem,30%,100%)}.ink-mde .ink-mde-search-panel:focus-within{outline-color:#6495ed;outline-style:solid}.ink-mde .ink-mde-search-input{background-color:transparent;border:none;border-radius:.25rem;color:inherit;font-size:inherit;outline:none;width:100%}.ink-mde .ink-mde-task-toggle{cursor:pointer;height:1rem;line-height:2em;margin:0 .25rem 0 0;position:relative;top:-1px;vertical-align:middle;width:1rem}.ink-mde .cm-editor{display:flex;flex-direction:column;position:relative}.ink-mde .cm-panels{background-color:unset;border:unset;z-index:10}.ink-mde .cm-searchMatch{background-color:#6495ed50}.ink-mde .cm-searchMatch-selected{background-color:#6495edcc}.ink-mde .cm-scroller{align-items:flex-start;display:flex;font-family:var(--ink-internal-font-family);font-size:var(--ink-internal-editor-font-size);line-height:var(--ink-internal-editor-line-height);overflow-x:auto;position:relative}.ink-mde .cm-content{display:block;flex-grow:2;flex-shrink:0;margin:0;outline:none;padding:0;white-space:nowrap}.ink-mde .cm-lineWrapping{display:flex;flex-direction:column;flex-shrink:1;overflow-wrap:unset;word-break:break-word;white-space:pre-wrap;width:100%;overflow-x:hidden}.ink-mde .cm-line .cm-code,.ink-mde .cm-line .cm-blockquote{word-break:break-all}.ink-mde .cm-line{font-family:var(--ink-internal-font-family);padding:0}.ink-mde .cm-line span{display:inline}.ink-mde .cm-line.cm-blockquote{background-color:var(--ink-internal-block-background-color);border-left:.25rem solid currentColor;padding:0 var(--ink-internal-block-padding)}.ink-mde .cm-line.cm-blockquote.cm-blockquote-open{border-top-left-radius:var(--ink-internal-border-radius);border-top-right-radius:var(--ink-internal-border-radius);padding-top:var(--ink-internal-block-padding)}.ink-mde .cm-line.cm-blockquote.cm-blockquote-close{border-bottom-left-radius:var(--ink-internal-border-radius);border-bottom-right-radius:var(--ink-internal-border-radius);padding-bottom:var(--ink-internal-block-padding)}.ink-mde .cm-line.cm-codeblock{background-color:var(--ink-internal-block-background-color);font-family:var(--ink-internal-code-font-family);padding:0 var(--ink-internal-block-padding)}.ink-mde .cm-line.cm-codeblock.cm-codeblock-open{border-radius:var(--ink-internal-border-radius) var(--ink-internal-border-radius) 0 0;padding-top:var(--ink-internal-block-padding)}.ink-mde .cm-line.cm-codeblock.cm-codeblock-close{border-radius:0 0 var(--ink-internal-border-radius) var(--ink-internal-border-radius);padding-bottom:var(--ink-internal-block-padding)}.ink-mde .cm-line .cm-code{background-color:var(--ink-internal-block-background-color);font-family:var(--ink-internal-code-font-family);padding:var(--ink-internal-inline-padding) 0}.ink-mde .cm-line .cm-code.cm-code-open{border-radius:var(--ink-internal-border-radius) 0 0 var(--ink-internal-border-radius);padding-left:var(--ink-internal-inline-padding)}.ink-mde .cm-line .cm-code.cm-code-close{border-radius:0 var(--ink-internal-border-radius) var(--ink-internal-border-radius) 0;padding-right:var(--ink-internal-inline-padding)}.ink-mde .cm-image-backdrop{background-color:var(--ink-internal-block-background-color)}.ink-mde .ink-mde-block-widget-container{padding:.5rem 0}.ink-mde .ink-mde-block-widget{background-color:var(--ink-internal-block-background-color);border-radius:var(--ink-internal-border-radius);padding:var(--ink-internal-block-padding)}";
var Vr = /* @__PURE__ */ p("<style> ");
const Wr = () => {
  const [e, n] = Y(), [t, r] = R(fe(e()));
  return Ln(() => {
    r(fe(e()));
  }), Re(() => {
    const o = window.matchMedia("(prefers-color-scheme: dark)"), i = (a) => {
      const {
        editor: s,
        root: l,
        workQueue: c
      } = e();
      l.isConnected ? c.enqueue(async () => {
        const f = await ue([e, n]);
        s.dispatch({
          effects: f
        }), r(fe(e()));
      }) : o.removeEventListener("change", i);
    };
    o.addEventListener("change", i);
  }), (() => {
    var o = m(Vr), i = o.firstChild;
    return me(() => xe(i, "data", `.ink {
  ${t().join(`
  `)}
}
${Rr}`)), o;
  })();
};
var Fr = /* @__PURE__ */ p('<div class="ink ink-mde"><!$><!/><!$><!/><!$><!/><div class=ink-mde-editor></div><!$><!/>');
const Ur = (e) => {
  const [n, t] = Y(), r = (o) => {
    t(ee(n(), {
      root: o
    }));
  };
  return (() => {
    var o = m(Fr), i = o.firstChild, [a, s] = h(i.nextSibling), l = a.nextSibling, [c, f] = h(l.nextSibling), _ = c.nextSibling, [y, S] = h(_.nextSibling), w = y.nextSibling, q = w.nextSibling, [I, T] = h(q.nextSibling);
    return He(r, o), mn(o, gn(zn), !1, !0), g(o, d(Wr, {}), a, s), g(o, d(x, {
      get when() {
        return n().options.files.clipboard || n().options.files.dragAndDrop;
      },
      get children() {
        return d($r, {});
      }
    }), c, f), g(o, d(x, {
      get when() {
        return n().options.interface.toolbar;
      },
      get children() {
        return d(Nr, {});
      }
    }), y, S), g(w, d(_r, {
      get target() {
        return e.target;
      }
    })), g(o, d(x, {
      get when() {
        return n().options.readability || n().options.interface.attribution;
      },
      get children() {
        return d(hr, {
          store: [n, t]
        });
      }
    }), I, T), ve(), o;
  })();
}, cn = En([() => be(), (e) => typeof e == "function" ? e(be()) : e]), Qr = (e) => (
  // eslint-disable-next-line solid/reactivity
  d(cn.Provider, {
    get value() {
      return e.store;
    },
    get children() {
      return e.children;
    }
  })
), Y = () => jn(cn), dn = (e) => d(Qr, {
  get store() {
    return e.store;
  },
  get children() {
    return d(Ur, {
      get store() {
        return e.store;
      },
      get target() {
        return e.target;
      }
    });
  }
});
var Xr = /* @__PURE__ */ p("<div class=ink-mde-textarea>");
const so = (e) => e, lo = (e) => e, co = (e) => e, Kr = (e, n = {}) => {
  const t = Ce(n);
  return Zr(), pn(() => d(dn, {
    store: t,
    target: e
  }), e), en(t);
}, uo = (e, n = {}) => e.querySelector(An) ? Kr(e, n) : un(e, n), Yr = ({
  key: e = "",
  type: n,
  value: t
}) => new Proxy({
  key: e,
  type: n || "default"
}, {
  get: (r, o, i) => o === "value" && !r[o] ? (r.value = t(), Xe(r.value) ? r.value.then((a) => r.value = a) : r.value) : r[o]
}), J = Yr, un = (e, n = {}) => {
  const t = Ce(n);
  return kn(() => d(dn, {
    store: t,
    target: e
  }), e), en(t);
}, fo = (e = {}) => (Ce(e), ""), Zr = () => {
  let e, n;
  e = window._$HY || (window._$HY = {
    events: [],
    completed: /* @__PURE__ */ new WeakSet(),
    r: {}
  }), n = (t) => t && t.hasAttribute && (t.hasAttribute("data-hk") ? t : n(t.host && t.host instanceof Node ? t.host : t.parentNode)), ["click", "input"].forEach((t) => document.addEventListener(t, (r) => {
    let o = r.composedPath && r.composedPath()[0] || r.target, i = n(o);
    i && !e.completed.has(i) && e.events.push([i, r]);
  })), e.init = (t, r) => {
    e.r[t] = [new Promise((o, i) => r = o), r];
  }, e.set = (t, r, o) => {
    (o = e.r[t]) && o[1](r), e.r[t] = [r];
  }, e.unset = (t) => {
    delete e.r[t];
  }, e.load = (t, r) => {
    if (r = e.r[t])
      return r[0];
  };
}, mo = (e, n = {}) => {
  const t = m(Xr), r = e.value;
  e.after(t), e.style.display = "none";
  const o = un(t, {
    doc: r,
    ...n
  });
  return e.form && e.form.addEventListener("submit", () => {
    e.value = o.getDoc();
  }), o;
};
export {
  W as a,
  tn as b,
  lo as c,
  so as d,
  co as e,
  Q as f,
  Yr as g,
  Kr as h,
  uo as i,
  J as j,
  fo as k,
  je as l,
  de as p,
  un as r,
  Zr as s,
  mo as w
};
//# sourceMappingURL=index-B3wUcuoh.js.map
